package com.zt.plat.module.base.service.base;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.api.dto.MaterialOtherDTO;
import com.zt.plat.module.base.controller.admin.base.vo.MaterialOtherPageReqVO;
import com.zt.plat.module.base.controller.admin.base.vo.MaterialOtherRespVO;
import com.zt.plat.module.base.controller.admin.base.vo.MaterialOtherSaveReqVO;
import com.zt.plat.module.base.dal.dataobject.base.MaterialOtherDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 物料拓展数据 Service 接口
 *
 * @author 后台管理
 */
public interface MaterialOtherService {

    /**
     * 创建物料拓展数据
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    MaterialOtherRespVO createMaterialOther(@Valid MaterialOtherSaveReqVO createReqVO);

    /**
     * 更新物料拓展数据
     *
     * @param updateReqVO 更新信息
     */
    void updateMaterialOther(@Valid MaterialOtherSaveReqVO updateReqVO);

    /**
     * 删除物料拓展数据
     *
     * @param id 编号
     */
    void deleteMaterialOther(Long id);

    /**
    * 批量删除物料拓展数据
    *
    * @param ids 编号
    */
    void deleteMaterialOtherListByIds(List<Long> ids);

    /**
     * 获得物料拓展数据
     *
     * @param id 编号
     * @return 物料拓展数据
     */
    MaterialOtherDO getMaterialOther(Long id);

    /**
     * 获得物料拓展数据分页
     *
     * @param pageReqVO 分页查询
     * @return 物料拓展数据分页
     */
    PageResult<MaterialOtherDO> getMaterialOtherPage(MaterialOtherPageReqVO pageReqVO);

    void enableMaterialOtherList(List<MaterialOtherRespVO> saveReqVOS);

    List<MaterialOtherDTO> getMaterialOtherNoPage(MaterialOtherDTO respVO);
}